Redmine - Defect #19091

SCM integration broken with JRuby (partial fix)
2015-02-12 01:19 - Matthew Bloch

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version:

Resolution: Wont fix Affected version: 2.6.1
Description

When running Redmine (2.6.1) under JRuby (1.7.19), the SCM integration is broken due to a long-standing problem with JRuby and
10.popen's "r+" mode (described at https:/github.com/jruby/jruby/issues/779).

It shows up in the front-end as a 500 error and the external command reporting "Bad file descriptor".

As far as | understand it this can't be fixed without some changes to Java, but we can avoid triggering the bug by not using the r+
mode unnecessarily.

In lib/redmine/scm/adapters/abstract_adapter.rb:254 in the "shellout" method we have this code:

mode = "r+"
I0.popen (cmd, mode) do |iol
io.set_encoding ("ASCII-8BRIT") if io.respond_to? (:set_encoding)
io.close_write unless options|[:write_stdin]
block.call(io) if block_given?
end

but we can avoid the JRuby bug in many situations by changing this to:
mode = options[:write_stdin] ? "r+" : "r"
IO0.popen (cmd, mode) do |io]
io.set_encoding ("ASCII-8BIT") if io.respond_to? (:set_encoding)
block.call(io) if block_given?
end

i.e. not using "r+" mode when we don't need to - | think this code is equivalent.

As far as | can tell only GitAdapter.revisions needs the :write_stdin option, and we could eliminate that one usage by pushing all the
revisions onto the command line instead.

| hope that makes sense.

Associated revisions

Revision 14012 - 2015-02-15 12:17 - Toshi MARUYAMA
add redmine.org issue link of jruby 10.popen() at .travis.yml (#19091)

Revision 14129 - 2015-03-18 14:55 - Toshi MARUYAMA
Merged r14012 from trunk to 2.6-stable

add redmine.org issue link of jruby 10.popen() at .travis.yml (#19091)

History

#1 - 2015-02-15 08:24 - Toshi MARUYAMA
Tests fails on trunk r14010.

$ ruby test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb -n test_path_space
Run options: -n test_path_space —--seed 9622
https://github.com/jruby/jruby/issues/779
https://www.redmine.org/projects/redmine/repository/svn/revisions/14010

# Running:
E
Finished in 0.124227s, 8.0498 runs/s, 16.0996 assertions/s.

1) Error:

MercurialAdapterTest#test_path_space:

Redmine: :Scm: :Adapters::CommandFailed: closing non-duplex IO for writing
lib/redmine/scm/adapters/abstract_adapter.rb:270:in “rescue in shellout'
lib/redmine/scm/adapters/abstract_adapter.rb:249:in "shellout'
lib/redmine/scm/adapters/mercurial_adapter.rb:64:in “hgversion_from_command_line'
lib/redmine/scm/adapters/mercurial_adapter.rb:57:in ~hgversion'
lib/redmine/scm/adapters/mercurial_adapter.rb:46:in "client_version'
lib/redmine/scm/adapters/abstract_adapter.rb:60:in “client_version_above?'
lib/redmine/scm/adapters/mercurial_adapter.rb:50:in ‘client_available'
test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb:33:in “setup'

1 runs, 2 assertions, 0 failures, 1 errors, 0 skips

#2 - 2015-02-15 08:25 - Toshi MARUYAMA
Previous note test on ruby 1.9.3p551 (2014-11-13 revision 48407) [x86_64-linux]

#3 - 2015-04-14 09:28 - Toshi MARUYAMA

JRuby team says this issue will fix in JRuby 9000.
https://github.com/jruby/jruby/issues/779#issuecomment-87487830

#4 - 2015-04-14 09:51 - Matthew Bloch

- Status changed from New to Resolved

I've not tested it but if the POSIX implementation has changed in JRuby, this bug isn't going to be valid or useful. I'll reopen if it proves a problem
later.

#5 - 2015-05-13 04:02 - Toshi MARUYAMA
- Status changed from Resolved to Closed

- Resolution set to Wont fix
